
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/berry_sethi.hh>
%}
%define alg_berry_sethi_interface(Automaton, GenAutomaton, Series, Exp, HList)
static void berry_sethi(Automaton& a, const Exp& e) ;
static void berry_sethi(GenAutomaton& a, const Exp& e) ;
%enddef
%define alg_berry_sethi_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  void berry_sethi(Automaton& a, const Exp& e) { return vcsn::berry_sethi(*a, e); }
static  void berry_sethi(GenAutomaton& a, const Exp& e) { return vcsn::berry_sethi(*a, e); }
%enddef
%define alg_interface_berry_sethi(Kind)
%{
struct Kind ##_alg_berry_sethi {
alg_berry_sethi_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_berry_sethi(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_berry_sethi {
alg_berry_sethi_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_berry_sethi {
alg_berry_sethi_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
