
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/equivalent.hh>
%}
%define alg_equivalent_interface(Automaton, GenAutomaton, Series, Exp, HList)
static bool are_equivalent(const Automaton& a1, const Automaton& a2) ;
static bool are_equivalent(const GenAutomaton& a1, const GenAutomaton& a2) ;
%enddef
%define alg_equivalent_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  bool are_equivalent(const Automaton& a1, const Automaton& a2) { return vcsn::are_equivalent(*a1, *a2); }
static  bool are_equivalent(const GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::are_equivalent(*a1, *a2); }
%enddef
%define alg_interface_equivalent(Kind)
%{
struct Kind ##_alg_equivalent {
alg_equivalent_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_equivalent(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_equivalent {
alg_equivalent_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_equivalent {
alg_equivalent_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
