
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/isomorph.hh>
%}
%define alg_isomorph_interface(Automaton, GenAutomaton, Series, Exp, HList)
static bool are_isomorphic(const Automaton& a1, const Automaton& a2) ;
static bool are_isomorphic(const GenAutomaton& a1, const GenAutomaton& a2) ;
%enddef
%define alg_isomorph_interface_impl(Automaton, GenAutomaton, Series, Exp, HList)
static  bool are_isomorphic(const Automaton& a1, const Automaton& a2) { return vcsn::are_isomorphic(*a1, *a2); }
static  bool are_isomorphic(const GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::are_isomorphic(*a1, *a2); }
%enddef
%define alg_interface_isomorph(Kind)
%{
struct Kind ##_alg_isomorph {
alg_isomorph_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
%enddef
%define decl_alg_isomorph(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_isomorph {
alg_isomorph_interface_impl(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%}
struct Kind ##_alg_isomorph {
alg_isomorph_interface(Kind ##_types::Kind ##_auto_t, \
                     Kind ##_types::gen_## Kind ##_auto_t, \
                     Kind ##_types::Kind ##_series_set_elt_t, \
                     Kind ##_types::Kind ##_exp_t, std::list<int>)
};
%enddef
